=== debian/changelog ===
chuffed (0.13.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1063388)
  * Use libmurmurhash instead of included implementation

 -- Kari Pahula <kaol@debian.org>  Sat, 10 Feb 2024 14:02:14 +0200
