=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

# Upstream doesn't recommend using Chuffed as a library.  See
# https://github.com/chuffed/chuffed/pull/182
execute_after_dh_install:
	rm -r debian/chuffed-flatzinc/usr/lib debian/chuffed-flatzinc/usr/include
