=== debian/watch ===
# Compulsory line, this is a version 4 file.
version=4

# Direct Git.
opts="mode=git" https://github.com/chuffed/chuffed.git \
    refs/tags/([\d\.]+)

# Upstream has been doing releases with tags only, ignore Github's
# release pages.
